#include<WiFiSSLClient.h>
#include <WiFi101.h>
#include <SPI.h>
#include <TelegramBot.h>
#include <dht11.h>
dht11 DHT;
#define DHT11_PIN 6 //pin a cui è collegato il dht11
String temperature ,hum,terreno;
int count;
// Initialize Wifi connection to the router
char ssid[] = "";             // your network SSID (name)
char pass[] = "";           // your network key

const char* host = "54.86.132.254"; //data.sparkfun.com
const char* publicKey = "";
const char* privateKey = "";

// Initialize Telegram BOT
const char BotToken[] = "";
const char BotName[] = "";
const char BotUsername[] = "";
int motorPin =  8; // il numero del pin a cui è collegato il relè delle pompa
int switchState = 0;
int sensorPin = A0; //il pin analogico a cui è collegato sensore umidità terreno
int sensorValue = 0;
int resetpin= 12;
 int r;
WiFiSSLClient client;
TelegramBot bot (BotToken, BotName, BotUsername, client);
TelegramKeyboard keyboard_one;

void(* resetFunc) (void) = 0;

void setup() {
 
  count=0;
 Serial.begin(9600);
 // while (!Serial) {}
 delay(2000);
   Serial.println("setup");
      digitalWrite(resetpin, HIGH);
  pinMode(resetpin, OUTPUT);

   pinMode(motorPin, OUTPUT);
   digitalWrite(motorPin, HIGH);
 delay(500);
    digitalWrite(motorPin,LOW);
     delay(500);
    digitalWrite(motorPin,HIGH);
   //pinMode(motorPin, OUTPUT);
   //digitalWrite(motorPin, LOW);
  // put your setup code here, to run once:
   pinMode(sensorPin, INPUT);
   
  // attempt to connect to Wifi network:
  ////Serial.print("Connecting Wifi: ");
  ////Serial.println(ssid);
  while (WiFi.begin(ssid, pass) != WL_CONNECTED) {
    ////Serial.print(".");
    delay(500);
  }
  //Serial.println("");
  //Serial.println("WiFi connected");

 const char* row_one[] = {"temp", "umid","terreno"};
  keyboard_one.addRow(row_one, 3);
  bot.begin();

}

void loop() {
   count++; 
   sensorValue = analogRead(sensorPin);
   r = map(sensorValue, 0, 1023, 0, 100);
  terreno=String(r);
 //  terreno=String(sensorValue);
   //Serial.println("Valore terreno: "+terreno);
  int chk;
  ////Serial.print("DHT11, \t");
  chk = DHT.read(DHT11_PIN);    // READ DATA
  hum = String(DHT.humidity);
  temperature= String(DHT.temperature);
  switch (chk){
    case DHTLIB_OK:  
                //Serial.println("OK,\t");
                //Serial.println("Temp: "+temperature);
                //Serial.println("Hum: "+hum);  
                break;
    case DHTLIB_ERROR_CHECKSUM: 
                ////Serial.print("Checksum error,\t"); 
                break;
    case DHTLIB_ERROR_TIMEOUT: 
                ////Serial.print("Time out error,\t"); 
                break;
    default: 
                ////Serial.print("Unknown error,\t"); 
                break;
  }


    message m = bot.getUpdates(); // Read new messages
    if ( m.chat_id != 0 ){ // Checks if there are some updates

     if (m.text=="temp") bot.sendMessage(m.chat_id,"Temperatura Aria: "+temperature+"°C",keyboard_one);
     if (m.text=="umid") bot.sendMessage(m.chat_id,"Umidità Aria: "+hum+"%",keyboard_one);  
     if (m.text=="terreno") bot.sendMessage(m.chat_id,"Umidità Terreno: "+terreno+"%",keyboard_one);    
     if (m.text=="innaffia") {
 
    bot.sendMessage(m.chat_id,"Sto innaffiando",keyboard_one); 
    digitalWrite(motorPin, LOW);
    delay(10000);
    digitalWrite(motorPin, HIGH);
    bot.sendMessage(m.chat_id,"Ho innaffiato",keyboard_one);  
     }

     // Serial.println(m.text);
    } else {
      //Serial.println("no new message");
    }

//ogni 30 min faccio un reset perchè tende a bloccarsi con il caldo
 if (count >=2400){
     bot.sendMessage(69668132,"sto resettando",keyboard_one); 
 // Serial.println("reset");
  delay(500);
  digitalWrite(resetpin, HIGH);
  delay(10);
  digitalWrite(resetpin, LOW);
 // Serial.println("resetfinito");
 }
     
  //ogni 15 minuti perchè ogni secondo count aumenta di 2 (c'è 500ms al termine del loop)
 if (count >=600){
  inviadati();
 }
 innaffia();
 delay(1000);
}
void innaffia(){
   if (r >= 40) {
   pinMode(motorPin, OUTPUT);
   digitalWrite(motorPin, HIGH);
    if (switchState == 0){
    switchState = 1;
    digitalWrite(motorPin, LOW);
    delay(10000);
    digitalWrite(motorPin, HIGH);
  
   bot.sendMessage(69668132,"Ho innaffiato",keyboard_one); 
   }
   }
  else {
      digitalWrite(motorPin, HIGH);
      switchState = 0;
  }

}
void inviadati(){

  WiFiClient client1;
 
 //if ( !client1.connect(host, 80) )
 // {
    // Error: 4 - Could not make a TCP connection
  // ////Serial.println(F("Error: 4"));
 // }
if (client1.connect(host, 80)) {
 //Serial.println("connected to server");

  String url = "/input/"; 
  url += publicKey;
  url += "?private_key=";
  url += privateKey;
  url += "&temp=";
  url += temperature;
  url +="&humidity=";
  url += hum;
  url +="&terreno=";
  url += terreno;
  
 client1.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");

  while (client1.connected())
  {
    if ( client1.available() )
    {
      char c = client1.read();
      //Serial.print(c);
    }      
  }
  


}
count=0;
}
